function addon_update_laseranimation(name,tint)

	if data.raw.projectile[name] then
		data.raw.projectile[name].animation.filename = "__base__/graphics/entity/laser/laser-to-tint-medium.png"
		data.raw.projectile[name].animation.width = 12
		data.raw.projectile[name].animation.height = 33
		data.raw.projectile[name].animation.blend_mode = "additive"
		if tint ~= nil then
			data.raw.projectile[name].animation.tint = tint
		end
	end
	
end


function addon_change_itemrecipe_icon(name,icon,extratype)

	if data.raw.item[name] then data.raw.item[name].icon = icon end
	if data.raw.recipe[name] then data.raw.recipe[name].icon = icon end
	if extratype ~= nil then
		if data.raw[extratype][name] then data.raw[extratype][name].icon = icon end
	end
end


function addon_change_icon(type,name,icon)

	if type ~= nil and name ~= nil and icon ~= nil then
		if data.raw[type][name] then data.raw[type][name].icon = icon end
	end
end


function addon_update_turret_tint(origin,type,name,base_tint,gun_tint,icon,laser_type)

	if data.raw[type][name] then
		
		data.raw[type][name].icon = icon
		data.raw.item[name].icon = icon

		if origin == "bobs" then		
			data.raw[type][name]["folded_animation"]["layers"][2].tint = gun_tint
			data.raw[type][name]["preparing_animation"]["layers"][2].tint = gun_tint 
			data.raw[type][name]["folding_animation"]["layers"][2].tint = gun_tint 

			data.raw[type][name]["prepared_animation"]["layers"][2].tint = gun_tint
			if type == "ammo-turret" then 
				data.raw[type][name]["attacking_animation"]["layers"][2].tint = gun_tint 
			else
				addon_update_laseranimation(laser_type)
				data.raw[type][name]["attack_parameters"]["ammo_type"]["action"][1]["action_delivery"][1].projectile = laser_type
			end

			data.raw[type][name]["base_picture"]["layers"][2].tint = base_tint
			
		elseif origin == "base" then
		
			if type == "ammo-turret" then 

				data.raw[type][name]["folded_animation"] 	= bob_turret_extension{frame_count=1, line_length = 1, type = "gun", tint = gun_tint}
				data.raw[type][name]["preparing_animation"] 	= bob_turret_extension{type = "gun", tint = gun_tint}
				data.raw[type][name]["folding_animation"] 	= bob_turret_extension{run_mode = "backward", type = "gun", tint = gun_tint}
				data.raw[type][name]["prepared_animation"] 	= bob_turret_attack{frame_count=1, type = "gun", tint = gun_tint}
				data.raw[type][name]["attacking_animation"] 	= bob_turret_attack{type = "gun", tint = gun_tint}

				data.raw[type][name]["base_picture"] 		= bob_gun_turret_base{type = "gun", tint = base_tint}
				
			else 	

				data.raw[type][name]["folded_animation"] 	= bob_laser_turret_extension{frame_count=1, line_length = 1, tint = gun_tint}
				data.raw[type][name]["preparing_animation"] 	= bob_laser_turret_extension{tint = gun_tint}
				data.raw[type][name]["folding_animation"] 	= bob_laser_turret_extension{run_mode = "backward", tint = gun_tint}
				data.raw[type][name]["prepared_animation"] 	= bob_laser_turret_attack{tint = gun_tint}
				
				addon_update_laseranimation(laser_type)
				data.raw[type][name]["attack_parameters"]["ammo_type"]["action"][1]["action_delivery"][1].projectile = laser_type
				
				data.raw[type][name]["base_picture"] 		= bob_laser_turret_base{type = "laser", tint = base_tint}
			end
		end
	end
end


function addon_subgroup_order(type,name,subgroup,order)

	if type ~= nil and name ~= nil and subgroup ~= nil then
		if data.raw["item-subgroup"][subgroup] and data.raw[type][name] then
				data.raw[type][name].subgroup = subgroup
		end
	end
	if order ~= nil and type  ~= nil and name ~= nil then
		if data.raw[type][name] then data.raw[type][name].order = order end
	end

end


function addon_animation4(picture,tint)
return 	{
		north = 
		{
			layers =
			{
				{
					filename = picture,
					width = 80,
					height = 80,
					frame_count = 8,
					animation_speed = 0.5
				},
				{
					filename = "__ExtraChests__/graphics/entity/pump/pump-mask.png",
					width = 80,
					height = 80,
					frame_count = 8,
					tint = tint,
					animation_speed = 0.5
				},
			}
		},
		east = 
		{
			layers =
			{
				{
					filename = picture,
					y = 80,
					width = 80,
					height = 80,
					frame_count = 8,
					animation_speed = 0.5
				},
				{
					filename = "__ExtraChests__/graphics/entity/pump/pump-mask.png",
					y = 80,
					width = 80,
					height = 80,
					frame_count = 8,
					tint = tint,
					animation_speed = 0.5
				},
			}
		},
		south = 
		{
			layers =
			{
				{
					filename = picture,
					y = 160,
					width = 80,
					height = 80,
					frame_count = 8,
					animation_speed = 0.5
				},
				{
					filename = "__ExtraChests__/graphics/entity/pump/pump-mask.png",
					y = 160,
					width = 80,
					height = 80,
					frame_count = 8,
					tint = tint,
					animation_speed = 0.5
				},
			}
		},
		west = 
		{
			layers =
			{
				{
					filename = picture,
					y = 240,
					width = 80,
					height = 80,
					frame_count = 8,
					animation_speed = 0.5
				},
				{
					filename = "__ExtraChests__/graphics/entity/pump/pump-mask.png",
					y = 240,
					width = 80,
					height = 80,
					frame_count = 8,
					tint = tint,
					animation_speed = 0.5
				}
			}
		}
	}

end


function addon_pipecoverspictures()
  return {
    north =
    {
      filename = "__base__/graphics/entity/pipe-covers/pipe-cover-north.png",
      priority = "extra-high",
      width = 44,
      height = 32
    },
    east =
    {
      filename = "__base__/graphics/entity/pipe-covers/pipe-cover-east.png",
      priority = "extra-high",
      width = 32,
      height = 32
    },
    south =
    {
      filename = "__base__/graphics/entity/pipe-covers/pipe-cover-south.png",
      priority = "extra-high",
      width = 46,
      height = 52
    },
    west =
    {
      filename = "__base__/graphics/entity/pipe-covers/pipe-cover-west.png",
      priority = "extra-high",
      width = 32,
      height = 32
    }
  }
end


function addon_pipecoverspicture(type)

	if type == "air" then
		data.raw["assembling-machine"]["air-pump"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-2"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-3"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-4"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-2"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-3"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
		data.raw["assembling-machine"]["air-pump-4"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/air-pipe-cover-north.png"
	elseif type == "water" then
		data.raw["assembling-machine"]["water-pump"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-2"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-3"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-4"]["fluid_boxes"][1]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-2"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-3"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
		data.raw["assembling-machine"]["water-pump-4"]["fluid_boxes"][2]["pipe_covers"]["north"].filename = "__ExtraChests__/graphics/entity/pipe-covers/water-pipe-cover-north.png"
       end
	
end

function addon_updatetech(name,icon,size)

 	if data.raw.technology[name] then data.raw.technology[name].icon = icon end
	if data.raw.technology[name] then data.raw.technology[name].icon_size = size end


end
